/* ------------------------------------------------------------------ */
/*      item            : IndexMark.hxx
        generated by    : Autobuild (abuild)
        date            : Mon 27 May 2024
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        original item   : IndexMark.dco
        made by         : Rene' van Paassen
        date            : 211022
        description     : Index marking for data log
        copyright       : (c) 2021-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated IndexMark.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#include <SimTime.hxx>

#include <ddff_ns.h>
#include <IndexPoint.hxx>
#include <varvector.hxx>
typedef dueca::varvector<DDFF_NS::IndexPoint> IndexPointList;

namespace dueca {
namespace  ddff {
 
/** Indicate where in the file buffers, a specific recording starts
    */
struct IndexMark
{
  /** typedef for internal reference */
  typedef IndexMark __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** Tick at which the index is marked */
  TimeTickType tick;

  /** Vector of marks */
  IndexPointList points;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  IndexMark();

  /** Constructor with arguments */
  IndexMark(
        const TimeTickType& tick,
        const IndexPointList& points);

  /** Constructor with all single (non-iterable) arguments */
  IndexMark(
        const TimeTickType& tick);

  /** copy constructor. */
  IndexMark(const IndexMark& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an IndexMark from amorphous storage. */
  IndexMark(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~IndexMark();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, IndexMark*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the IndexMark into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the IndexMark into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const IndexMark& ref) const;

  /** unpacks the IndexMark from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for IndexMark
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const IndexMark& o) const;

  /** Test for inequality. */
  inline bool operator != (const IndexMark& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  IndexMark& operator=(const IndexMark& o);

  /** prints the IndexMark to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} } 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca:: ddff::IndexMark& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca:: ddff::IndexMark& o,
                         const dueca:: ddff::IndexMark& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca:: ddff::IndexMark& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca:: ddff::IndexMark& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca:: ddff::IndexMark& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca:: ddff::IndexMark>();
template <>
inline const char* dueca::getclassname<const dueca:: ddff::IndexMark>()
{ return dueca::getclassname<dueca:: ddff::IndexMark>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    IndexMark is ever used inside other dco objects. */
template <>
struct dco_nested<dueca:: ddff::IndexMark> : public dco_isnested { };
};

#endif


