/* ------------------------------------------------------------------ */
/*      item            : ChannelDistribution.hxx
        generated by    : Autobuild (abuild)
        date            : Mon 27 May 2024
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : ChannelDistribution.dco
        made by         : Rene' van Paassen
        date            : 130102
        description     : Generated from a hard-coded version
        copyright       : (c) 2013-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated ChannelDistribution.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>



namespace dueca {
 
/** An automatically generated class
    */
struct ChannelDistribution
{
  /** typedef for internal reference */
  typedef ChannelDistribution __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


/** Enumerated type for an automatically generated object class */
  enum Distribution {
    /** only one channel end is SENDING or SENDING_RECEIVING */
    SOLO_SEND,
    /** Multiple channel ends can send. Only one end is the
        JOIN_MASTER, and this end receives all events (in such cases
        only event channels have a useful application) and re-sends
        these */
    JOIN_MASTER,
    /** Multiple channel ends can send. Each channel end
        independently sends its data to all clients. Is disabled for
        the time being, questionable whether this is practical. */
    MULTI_SEND,
    /** The organisation of the data distribution is not challenged
        or changed */
    NO_OPINION,
    /** This can be the result of a combination of two incompatible
        distribution types */
    CONFLICT
  };

  /** The value of the distribution for this object */
  Distribution distribution;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  ChannelDistribution();

  /** Constructor with arguments */
  ChannelDistribution(
        const Distribution& distribution);

  /** copy constructor. */
  ChannelDistribution(const ChannelDistribution& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an ChannelDistribution from amorphous storage. */
  ChannelDistribution(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~ChannelDistribution();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, ChannelDistribution*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the ChannelDistribution into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the ChannelDistribution into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const ChannelDistribution& ref) const;

  /** unpacks the ChannelDistribution from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for ChannelDistribution
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const ChannelDistribution& o) const;

  /** Test for inequality. */
  inline bool operator != (const ChannelDistribution& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  ChannelDistribution& operator=(const ChannelDistribution& o);

  /** prints the ChannelDistribution to a stream. */
  std::ostream & print(std::ostream& s) const;

// Additional custom code
#include "ChannelDistributionExtra.hxx"
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::ChannelDistribution& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::ChannelDistribution& o,
                         const dueca::ChannelDistribution& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::ChannelDistribution& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::ChannelDistribution& o)
{ o.unPackDataDiff(s); }
#endif

namespace dueca {
  const char* const getString(const dueca::ChannelDistribution::Distribution &o);
  void readFromString(dueca::ChannelDistribution::Distribution &o, const std::string& s);
  void getFirst(dueca::ChannelDistribution::Distribution &o);
  bool getNext(dueca::ChannelDistribution::Distribution &o);

  /** This function retrieves the classname of an ChannelDistribution::Distribution */
  template <>
  const char* getclassname<dueca::ChannelDistribution::Distribution>();
}; // end namespace dueca

#if !defined(__DCO_NOPACK)
void packData(::dueca::AmorphStore& s,
              const dueca::ChannelDistribution::Distribution &o);
void unPackData(::dueca::AmorphReStore& s,
                dueca::ChannelDistribution::Distribution &o);
#endif

PRINT_NS_START;
/** Print an object of type ChannelDistribution::Distribution */
inline std::ostream&
operator << (std::ostream& s, const dueca::ChannelDistribution::Distribution& o)
{ return s << dueca::getString(o); }
/** Read an object of type ChannelDistribution::Distribution */
inline std::istream&
/** Read an enum of type ChannelDistribution::Distribution */
operator >> (std::istream& s, dueca::ChannelDistribution::Distribution& o)
{ std::string tmp; s >> tmp; dueca::readFromString(o, tmp); return s; }
PRINT_NS_END;

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::ChannelDistribution& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::ChannelDistribution>();
template <>
inline const char* dueca::getclassname<const dueca::ChannelDistribution>()
{ return dueca::getclassname<dueca::ChannelDistribution>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    ChannelDistribution is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::ChannelDistribution> : public dco_isnested { };
template <>
struct dco_nested<dueca::ChannelDistribution::Distribution> : public dco_isenum { };
};

#endif


