/* ------------------------------------------------------------------ */
/*      item            : ChannelEndUpdate.hxx
        generated by    : Autobuild (abuild)
        date            : Mon 27 May 2024
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : ChannelEndUpdate.dco
        made by         : Rene' van Paassen
        date            : 1301002
        description     : Generated from a hard-coded version
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated ChannelEndUpdate.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#include <NameSet.hxx>
#include <GlobalId.hxx>

namespace dueca {
 
/** Event data for updating channel registries
    */
struct ChannelEndUpdate
{
  /** typedef for internal reference */
  typedef ChannelEndUpdate __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


/** Type of update to be performed
 */
  enum UpdateType {
    /** Addition of a first consumer in a node */
    ADD_DESTINATION,
    /** Last consumer in a node is removed, data no longer needs to
        go here */
    REMOVE_DESTINATION,
    /** Issuing of an ID, by the administrative node, to a channel */
    ID_ISSUED,
    /** Specify master */
    SET_MASTER,
    /** Channel end must be deleted */
    DELETE_END
  };

  /** Type of update we are talking about */
  UpdateType update;

  /** Set of names describing the channel */
  NameSet name_set;

  /** Id for this channel end */
  GlobalId end_id;

  /** Id for a possible destination that has to be added to the
      transport stuff */
  GlobalId destination_id;

  /** transport class to be used when master known */
  uint8_t transportclass;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  ChannelEndUpdate(
        const uint8_t& transportclass = 0);

  /** Constructor with arguments */
  ChannelEndUpdate(
        const UpdateType& update,
        const NameSet& name_set,
        const GlobalId& end_id,
        const GlobalId& destination_id,
        const uint8_t& transportclass);

  /** copy constructor. */
  ChannelEndUpdate(const ChannelEndUpdate& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an ChannelEndUpdate from amorphous storage. */
  ChannelEndUpdate(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~ChannelEndUpdate();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, ChannelEndUpdate*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the ChannelEndUpdate into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the ChannelEndUpdate into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const ChannelEndUpdate& ref) const;

  /** unpacks the ChannelEndUpdate from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for ChannelEndUpdate
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const ChannelEndUpdate& o) const;

  /** Test for inequality. */
  inline bool operator != (const ChannelEndUpdate& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  ChannelEndUpdate& operator=(const ChannelEndUpdate& o);

  /** prints the ChannelEndUpdate to a stream. */
  std::ostream & print(std::ostream& s) const;

// Additional custom code
#include "ChannelEndUpdateExtra.hxx"
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::ChannelEndUpdate& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::ChannelEndUpdate& o,
                         const dueca::ChannelEndUpdate& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::ChannelEndUpdate& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::ChannelEndUpdate& o)
{ o.unPackDataDiff(s); }
#endif

namespace dueca {
  const char* const getString(const dueca::ChannelEndUpdate::UpdateType &o);
  void readFromString(dueca::ChannelEndUpdate::UpdateType &o, const std::string& s);
  void getFirst(dueca::ChannelEndUpdate::UpdateType &o);
  bool getNext(dueca::ChannelEndUpdate::UpdateType &o);

  /** This function retrieves the classname of an ChannelEndUpdate::UpdateType */
  template <>
  const char* getclassname<dueca::ChannelEndUpdate::UpdateType>();
}; // end namespace dueca

#if !defined(__DCO_NOPACK)
void packData(::dueca::AmorphStore& s,
              const dueca::ChannelEndUpdate::UpdateType &o);
void unPackData(::dueca::AmorphReStore& s,
                dueca::ChannelEndUpdate::UpdateType &o);
#endif

PRINT_NS_START;
/** Print an object of type ChannelEndUpdate::UpdateType */
inline std::ostream&
operator << (std::ostream& s, const dueca::ChannelEndUpdate::UpdateType& o)
{ return s << dueca::getString(o); }
/** Read an object of type ChannelEndUpdate::UpdateType */
inline std::istream&
/** Read an enum of type ChannelEndUpdate::UpdateType */
operator >> (std::istream& s, dueca::ChannelEndUpdate::UpdateType& o)
{ std::string tmp; s >> tmp; dueca::readFromString(o, tmp); return s; }
PRINT_NS_END;

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::ChannelEndUpdate& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::ChannelEndUpdate>();
template <>
inline const char* dueca::getclassname<const dueca::ChannelEndUpdate>()
{ return dueca::getclassname<dueca::ChannelEndUpdate>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    ChannelEndUpdate is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::ChannelEndUpdate> : public dco_isnested { };
template <>
struct dco_nested<dueca::ChannelEndUpdate::UpdateType> : public dco_isenum { };
};

#endif


