/* ------------------------------------------------------------------ */
/*      item            : DUECALogStatus.hxx
        generated by    : Autobuild (abuild)
        date            : Mon 27 May 2024
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        original item   : DUECALogStatus.dco
        made by         : Rene' van Paassen
        date            : 170521
        api             : DUECA_API
        description     : Status feedback hdf logging
        copyright       : (c) 2017-2022 TUDelft-AE-C&S
                        : (c) 2023 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated DUECALogStatus.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#include <stringoptions.h>

namespace dueca {
 
/** Status feedback for hdf logging
    */
struct DUECALogStatus
{
  /** typedef for internal reference */
  typedef DUECALogStatus __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** Status report on a logging action */
  vstring status;

  /** Error flag, indicating an error or problem */
  bool error;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  DUECALogStatus();

  /** Constructor with arguments */
  DUECALogStatus(
        const vstring& status,
        const bool& error);

  /** copy constructor. */
  DUECALogStatus(const DUECALogStatus& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an DUECALogStatus from amorphous storage. */
  DUECALogStatus(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~DUECALogStatus();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, DUECALogStatus*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the DUECALogStatus into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the DUECALogStatus into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const DUECALogStatus& ref) const;

  /** unpacks the DUECALogStatus from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for DUECALogStatus
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const DUECALogStatus& o) const;

  /** Test for inequality. */
  inline bool operator != (const DUECALogStatus& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  DUECALogStatus& operator=(const DUECALogStatus& o);

  /** prints the DUECALogStatus to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::DUECALogStatus& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::DUECALogStatus& o,
                         const dueca::DUECALogStatus& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::DUECALogStatus& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::DUECALogStatus& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::DUECALogStatus& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::DUECALogStatus>();
template <>
inline const char* dueca::getclassname<const dueca::DUECALogStatus>()
{ return dueca::getclassname<dueca::DUECALogStatus>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    DUECALogStatus is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::DUECALogStatus> : public dco_isnested { };
};

#endif


