/* ------------------------------------------------------------------ */
/*      item            : FillSet.hxx
        generated by    : Autobuild (abuild)
        date            : Mon 27 May 2024
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        original item   : FillSet.dco
        made by         : Rene' van Paassen
        date            : very old
        description     : For sending bulk data over reflective comm
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated FillSet.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#include <varvector.hxx>

namespace dueca {
 
/** An object used by the reflectiveFillPacker/UnPacker to send around data.
    should be optimized in the future
    */
struct FillSet
{
  /** typedef for internal reference */
  typedef FillSet __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** array with data, variable length */
  varvector<uint8_t> data;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  FillSet(
    size_t data_size = 0);

  /** Constructor with arguments */
  FillSet(
        const varvector<uint8_t>& data);

  /** copy constructor. */
  FillSet(const FillSet& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an FillSet from amorphous storage. */
  FillSet(::dueca::AmorphReStore& r);
#endif
  /** Constructor with sizes for all arrays that can be empty-initialised */
  FillSet(
            const dueca::DataWriterArraySize& data_size);


  /** destructor. */
  ~FillSet();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, FillSet*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the FillSet into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the FillSet into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const FillSet& ref) const;

  /** unpacks the FillSet from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for FillSet
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const FillSet& o) const;

  /** Test for inequality. */
  inline bool operator != (const FillSet& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  FillSet& operator=(const FillSet& o);

  /** prints the FillSet to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::FillSet& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::FillSet& o,
                         const dueca::FillSet& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::FillSet& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::FillSet& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::FillSet& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::FillSet>();
template <>
inline const char* dueca::getclassname<const dueca::FillSet>()
{ return dueca::getclassname<dueca::FillSet>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    FillSet is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::FillSet> : public dco_isnested { };
};

#endif


