/* ------------------------------------------------------------------ */
/*      item            : ModuleState.hxx
        generated by    : Autobuild (abuild)
        date            : Mon 27 May 2024
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : ModuleState.dco
        made by         : Rene' van Paassen
        date            : 130928
        category        : comm object specification
        description     : distributed state machine
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
        documentation   : DUECA_API
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated ModuleState.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>



namespace dueca {
 
/** Describes the state a module may be in.
    */
struct ModuleState
{
  /** typedef for internal reference */
  typedef ModuleState __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


/** Enum type for the different modulestate types
 */
  enum Type {
    /** Existing, but cannot yet start. */
    UnPrepared,
    /** Prepared to come to safe mode */
    InitialPrep,
    /** Activities in safe mode, but not
        prepared to go on yet. */
    Safe,
    /** Prepared to be started further. If there
        are critical activities, these are
        running in safe mode at least. Doubles
        as a command for going to this state. */
    Prepared,
    /** Activities in operating mode. Doubles as
        a command. */
    On,
    /** Not a real state, for comparison/state
        joining purposes. */
    Neutral,
    /** Not a valid state */
    Undefined
  };

  /** A class member */
  Type t;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  ModuleState();

  /** Constructor with arguments */
  ModuleState(
        const Type& t);

  /** copy constructor. */
  ModuleState(const ModuleState& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an ModuleState from amorphous storage. */
  ModuleState(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~ModuleState();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, ModuleState*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the ModuleState into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the ModuleState into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const ModuleState& ref) const;

  /** unpacks the ModuleState from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for ModuleState
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const ModuleState& o) const;

  /** Test for inequality. */
  inline bool operator != (const ModuleState& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  ModuleState& operator=(const ModuleState& o);

  /** prints the ModuleState to a stream. */
  std::ostream & print(std::ostream& s) const;

// Additional custom code
#include "ModuleStateExtra.hxx"
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::ModuleState& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::ModuleState& o,
                         const dueca::ModuleState& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::ModuleState& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::ModuleState& o)
{ o.unPackDataDiff(s); }
#endif

namespace dueca {
  const char* const getString(const dueca::ModuleState::Type &o);
  void readFromString(dueca::ModuleState::Type &o, const std::string& s);
  void getFirst(dueca::ModuleState::Type &o);
  bool getNext(dueca::ModuleState::Type &o);

  /** This function retrieves the classname of an ModuleState::Type */
  template <>
  const char* getclassname<dueca::ModuleState::Type>();
}; // end namespace dueca

#if !defined(__DCO_NOPACK)
void packData(::dueca::AmorphStore& s,
              const dueca::ModuleState::Type &o);
void unPackData(::dueca::AmorphReStore& s,
                dueca::ModuleState::Type &o);
#endif

PRINT_NS_START;
/** Print an object of type ModuleState::Type */
inline std::ostream&
operator << (std::ostream& s, const dueca::ModuleState::Type& o)
{ return s << dueca::getString(o); }
/** Read an object of type ModuleState::Type */
inline std::istream&
/** Read an enum of type ModuleState::Type */
operator >> (std::istream& s, dueca::ModuleState::Type& o)
{ std::string tmp; s >> tmp; dueca::readFromString(o, tmp); return s; }
PRINT_NS_END;

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::ModuleState& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::ModuleState>();
template <>
inline const char* dueca::getclassname<const dueca::ModuleState>()
{ return dueca::getclassname<dueca::ModuleState>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    ModuleState is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::ModuleState> : public dco_isnested { };
template <>
struct dco_nested<dueca::ModuleState::Type> : public dco_isenum { };
};

#endif


