/* ------------------------------------------------------------------ */
/*      item            : SimulationState.hxx
        generated by    : Autobuild (abuild)
        date            : Mon 27 May 2024
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : SimulationState.dco
        made by         : Rene' van Paassen
        date            : 130928
        category        : comm object specification
        description     : Basic named object or channel
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
        language        : C++
          documentation   : DUECA_API
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated SimulationState.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>



namespace dueca {
 
/** An automatically generated class
    */
struct SimulationState
{
  /** typedef for internal reference */
  typedef SimulationState __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


/** Enumerated type for an automatically generated object class */
  enum Type {
    /** A state, shared between the SimulationModule and
        HardwareModule. The simulation is poised to start. */
    HoldCurrent,
    /** In this state, the simulation is running. */
    Advance,
    /** In this state, the simulation is played again with recorded
        input. Most modules can simply run their Advance code for this
        @todo The replay functionality has not yet been implemented. */
    Replay,
    /** A state, exclusive for HardwareModule, in which the hardware is in
        the safe position, but not error code. */
    Inactive,
    /** Transition from inactive to HoldCurrent, for example lifting the
        simulator cab to neutral position. */
    Inactive_HoldCurrent,
    /** A transition state during which calibration is carried out. After
        calibration the state transitions to HoldCurrent. */
    Calibrate_HoldCurrent,
    /** A transition state from Advance, participation in the simulation,
        back to HoldCurrent. Transitional State. */
    Advance_HoldCurrent,
    /** A transition state from Replay, back to HoldCurrent. */
    Replay_HoldCurrent,
    /** A transition from HoldCurrent to inactive, for example going
        down. */
    HoldCurrent_Inactive,
    /** Not a state, for initialising combination. */
    Neutral,
    /** Undefined. */
    Undefined
  };

  /** the actual state */
  Type t;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  SimulationState();

  /** Constructor with arguments */
  SimulationState(
        const Type& t);

  /** copy constructor. */
  SimulationState(const SimulationState& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an SimulationState from amorphous storage. */
  SimulationState(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~SimulationState();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, SimulationState*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the SimulationState into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the SimulationState into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const SimulationState& ref) const;

  /** unpacks the SimulationState from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for SimulationState
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const SimulationState& o) const;

  /** Test for inequality. */
  inline bool operator != (const SimulationState& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  SimulationState& operator=(const SimulationState& o);

  /** prints the SimulationState to a stream. */
  std::ostream & print(std::ostream& s) const;

// Additional custom code
#include "SimulationStateExtra.hxx"
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::SimulationState& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::SimulationState& o,
                         const dueca::SimulationState& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::SimulationState& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::SimulationState& o)
{ o.unPackDataDiff(s); }
#endif

namespace dueca {
  const char* const getString(const dueca::SimulationState::Type &o);
  void readFromString(dueca::SimulationState::Type &o, const std::string& s);
  void getFirst(dueca::SimulationState::Type &o);
  bool getNext(dueca::SimulationState::Type &o);

  /** This function retrieves the classname of an SimulationState::Type */
  template <>
  const char* getclassname<dueca::SimulationState::Type>();
}; // end namespace dueca

#if !defined(__DCO_NOPACK)
void packData(::dueca::AmorphStore& s,
              const dueca::SimulationState::Type &o);
void unPackData(::dueca::AmorphReStore& s,
                dueca::SimulationState::Type &o);
#endif

PRINT_NS_START;
/** Print an object of type SimulationState::Type */
inline std::ostream&
operator << (std::ostream& s, const dueca::SimulationState::Type& o)
{ return s << dueca::getString(o); }
/** Read an object of type SimulationState::Type */
inline std::istream&
/** Read an enum of type SimulationState::Type */
operator >> (std::istream& s, dueca::SimulationState::Type& o)
{ std::string tmp; s >> tmp; dueca::readFromString(o, tmp); return s; }
PRINT_NS_END;

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::SimulationState& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::SimulationState>();
template <>
inline const char* dueca::getclassname<const dueca::SimulationState>()
{ return dueca::getclassname<dueca::SimulationState>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    SimulationState is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::SimulationState> : public dco_isnested { };
template <>
struct dco_nested<dueca::SimulationState::Type> : public dco_isenum { };
};

#endif


