/* ------------------------------------------------------------------ */
/*      item            : SnapshotState.hxx
        generated by    : Autobuild (abuild)
        date            : Mon 27 May 2024
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : SnapshotState.dco
        made by         : Rene' van Paassen
        date            : 130928
        category        : comm object specification
        description     : Basic named object or channel
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
        language        : C++
          documentation   : DUECA_API
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated SnapshotState.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>



namespace dueca {
 
/** Enum event type for keeping snapshot info
    */
struct SnapshotState
{
  /** typedef for internal reference */
  typedef SnapshotState __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


/** Enum type for the different snapshot states and commands
 */
  enum Type {
    /** clear memory used for snapshot */
    SnapClear,
    /** prepared module for taking snapshot */
    SnapPrepared,
    /** take the snapshot at the indicated time */
    SnapNow,
    /** confirm the snapshot has been taken */
    SnapTaken,
    /** say this module does not send a snapshot */
    SnapSendNotApplicable,
    /** confirm snapshot has been sent off */
    SnapSent,
    /** confirm snapshot data has been re-loaded */
    SnapLoaded,
    /** complain no data available */
    SnapNotFilled,
    /** command came too late */
    TooLateForSnap
  };

  /** actual state */
  Type state;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  SnapshotState();

  /** Constructor with arguments */
  SnapshotState(
        const Type& state);

  /** copy constructor. */
  SnapshotState(const SnapshotState& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an SnapshotState from amorphous storage. */
  SnapshotState(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~SnapshotState();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, SnapshotState*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the SnapshotState into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the SnapshotState into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const SnapshotState& ref) const;

  /** unpacks the SnapshotState from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for SnapshotState
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const SnapshotState& o) const;

  /** Test for inequality. */
  inline bool operator != (const SnapshotState& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  SnapshotState& operator=(const SnapshotState& o);

  /** prints the SnapshotState to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::SnapshotState& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::SnapshotState& o,
                         const dueca::SnapshotState& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::SnapshotState& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::SnapshotState& o)
{ o.unPackDataDiff(s); }
#endif

namespace dueca {
  const char* const getString(const dueca::SnapshotState::Type &o);
  void readFromString(dueca::SnapshotState::Type &o, const std::string& s);
  void getFirst(dueca::SnapshotState::Type &o);
  bool getNext(dueca::SnapshotState::Type &o);

  /** This function retrieves the classname of an SnapshotState::Type */
  template <>
  const char* getclassname<dueca::SnapshotState::Type>();
}; // end namespace dueca

#if !defined(__DCO_NOPACK)
void packData(::dueca::AmorphStore& s,
              const dueca::SnapshotState::Type &o);
void unPackData(::dueca::AmorphReStore& s,
                dueca::SnapshotState::Type &o);
#endif

PRINT_NS_START;
/** Print an object of type SnapshotState::Type */
inline std::ostream&
operator << (std::ostream& s, const dueca::SnapshotState::Type& o)
{ return s << dueca::getString(o); }
/** Read an object of type SnapshotState::Type */
inline std::istream&
/** Read an enum of type SnapshotState::Type */
operator >> (std::istream& s, dueca::SnapshotState::Type& o)
{ std::string tmp; s >> tmp; dueca::readFromString(o, tmp); return s; }
PRINT_NS_END;

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::SnapshotState& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::SnapshotState>();
template <>
inline const char* dueca::getclassname<const dueca::SnapshotState>()
{ return dueca::getclassname<dueca::SnapshotState>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    SnapshotState is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::SnapshotState> : public dco_isnested { };
template <>
struct dco_nested<dueca::SnapshotState::Type> : public dco_isenum { };
};

#endif


