/* ------------------------------------------------------------------ */
/*      item            : IncoVariable.hxx
        generated by    : Autobuild (abuild)
        date            : Mon 27 May 2024
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : IncoVariable.dco
        made by         : Rene' van Paassen
        date            : 1301004
        description     : Generated from a hard-coded version
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated IncoVariable.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#include <stringoptions.h>
#include "IncoVarType.hxx"
#include <map>
#include "IncoMode.hxx"
#include "IncoRole.hxx"
namespace dueca { typedef IncoMode TrimMode; }

namespace dueca {
 
/** This defines a variable that may be involved in trim condition
    calculation. For different trim modes, this variable may have
    different roles
    */
struct IncoVariable
{
  /** typedef for internal reference */
  typedef IncoVariable __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** Identifying name, mainly for feedback to the trimmer/experimenter */
  string32 name;

  /** The minimum (reasonable) value. */
  double min_value;

  /** The maximum (reasonable) value. */
  double max_value;

  /** Indicates how close the variable should be to its specified value,
      if this variable is used as a target */
  double tolerance;

  /** Type of variable, integer (for switches) or double */
  IncoVarType vartype;

  /** A map laying out the role of the variable for each trim mode */
  std::map<IncoMode,IncoRole> roles;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  IncoVariable();

  /** Constructor with arguments */
  IncoVariable(
        const string32& name,
        const double& min_value,
        const double& max_value,
        const double& tolerance,
        const IncoVarType& vartype,
        const std::map<IncoMode,IncoRole>& roles);

  /** Constructor with all single (non-iterable) arguments */
  IncoVariable(
        const string32& name,
        const double& min_value,
        const double& max_value,
        const double& tolerance,
        const IncoVarType& vartype);

  /** copy constructor. */
  IncoVariable(const IncoVariable& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an IncoVariable from amorphous storage. */
  IncoVariable(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~IncoVariable();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, IncoVariable*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the IncoVariable into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the IncoVariable into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const IncoVariable& ref) const;

  /** unpacks the IncoVariable from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for IncoVariable
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const IncoVariable& o) const;

  /** Test for inequality. */
  inline bool operator != (const IncoVariable& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  IncoVariable& operator=(const IncoVariable& o);

  /** prints the IncoVariable to a stream. */
  std::ostream & print(std::ostream& s) const;

// Additional custom code
#include "IncoVariableExtra.hxx"
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::IncoVariable& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::IncoVariable& o,
                         const dueca::IncoVariable& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::IncoVariable& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::IncoVariable& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::IncoVariable& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::IncoVariable>();
template <>
inline const char* dueca::getclassname<const dueca::IncoVariable>()
{ return dueca::getclassname<dueca::IncoVariable>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    IncoVariable is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::IncoVariable> : public dco_isnested { };
};

#endif


